# -*- coding: utf-8 -*-
"""
@author: Anna
"""

import sys, getopt
import xml.etree.ElementTree as ET
import csv


def get_attributes(root):
    attNames = set()
    for row in root:
        for att in row.attrib.keys():
            attNames.add(att)
    return attNames


def xml2csv(ifile, output_file_path):
    # open XML
    d = ET.parse(ifile)
    root = d.getroot()
    n_rows = len(root)
    first = True
    if n_rows == 0:
        raise Exception("This file does not contain any row")
    else:
        att_names = get_attributes(root)
        #Output metadata
        output_file = open(output_file_path, "w")
        for attn in att_names:
            if first:
                first = False
            else:
                output_file.write(",")
            output_file.write(attn)

    output_file.write("\n")
    #output data
    for row in root:
        first = True
        for attn in att_names:
            if first:
                first = False
            else:
                output_file.write(",")
            att = row.get(attn)
            if att is None:
                output_file.write("?")
            else:
                output_file.write(att)
        output_file.write("\n")
    output_file.close()


def main():
    # Store input and output file names
    ifile = ''
    output_file_path = ''
    # Read command line args
    my_opts, args = getopt.getopt(sys.argv[1:], "i:o:")

    for option, value in my_opts:
        if option == '-i':
            ifile = value
        elif option == '-o':
            output_file_path = value
        else:
            raise Exception("Usage: %s -i input -o output /n" % sys.argv[0])

    xml2csv(ifile, output_file_path)


if __name__ == "__main__":
    main()
